/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef WSENSORNODE_HELPER_H
#define WSENSORNODE_HELPER_H

#include "ns3/log.h"
#include "ns3/config.h"
#include "ns3/trace-helper.h"
#include "ns3/inet-socket-address.h"
#include "ns3/packet-socket-address.h"
#include "ns3/string.h"
#include "ns3/names.h"
#include <stdint.h>
#include <string>
#include "ns3/uinteger.h"
#include "ns3/object-factory.h"
#include "ns3/address.h"
#include "ns3/attribute.h"
#include "ns3/attribute-helper.h"
#include "ns3/net-device.h"
#include "ns3/node-container.h"
#include "ns3/application-container.h"
#include "ns3/application.h"
#include "ns3/wsimulationmanager.h"
#include "ns3/grid-sn.h"

namespace ns3 {

class WSensorNodeHelper : public Object
{
public:
  static TypeId GetTypeId (void);

  //Create helpers, to make easyer working with apps
  WSensorNodeHelper();
  WSensorNodeHelper(uint16_t port, Ptr<WsimulationManager> manager,Ptr<Grid> grid,uint16_t k,uint16_t p,double dr,uint16_t ps);


  //MyAppHelper(Ipv4Address address);
  ~WSensorNodeHelper();


  void SetAttribute (std::string name, const AttributeValue &value);

  /*
   * Install an ns3::MyApp on the each node of the NodeContainer configured with all the attributes set with SetAttribute.
   * \param NodeContainer
   * \returns ApplicationContainer
   *
   */

  ApplicationContainer Install (NodeContainer c) const;


  /*
   *Install an ns3::MyApp on the node configured with all the attributes set with SetAttribute.
   * \param node, the node on which an MyApp will be installed
   * \returns Ptr to the installed application
   */

  Ptr<Application> InstallPriv (Ptr<Node> node) const;

private:
  uint16_t      m_port;
  Ptr<WsimulationManager> m_sim_manager;
  Ptr<Grid> m_grid;
  uint16_t      m_k;
  ObjectFactory m_factory;
  uint16_t packNum; //number of packet sent
  double dataRate; //link datarate in Mbps
  uint16_t packetSize; //packet size in bytes

};

}

#endif /* SENSORNODE_HELPER_H */

