/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */

#include "grid-sn.h"

namespace ns3 {

//Zagotovi, da se registrira TypeId
NS_OBJECT_ENSURE_REGISTERED (Grid);

TypeId
Grid::GetTypeId (void)
{
	static TypeId tid = TypeId ("ns3::Grid")
	                    .SetParent<Object> ()
	                    .AddConstructor<Grid> ();
	return tid;
}


Grid::Grid() {}

Grid::~Grid() {}


//the grid with diagonal
void Grid::initialize(int n) {

	is_grid = false;

	this->n = n;

	for (int i = 0; i < n; ++i)
	{
		field.push_back(Array());
		
	}
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < n; ++j)
		{
			field[j].push_back(WiredNode());
		}
		
	}
}


//the grid without diagonal
void Grid::initializeGrid(int n) {

	is_grid = true;

	this->n = n;

	for (int i = 0; i < n; ++i)
	{
		field.push_back(Array());
		
	}
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < n; ++j)
		{
			field[j].push_back(WiredNodeGrid());
		}
		
	}
}

//just info if it is diagonal or grid
bool Grid::isGrid(void){
	return is_grid;
}

void Grid::addNode(int y, int x, Ptr<Node> node){
	field[y][x].insertNode(node,y,x);
}

WiredNode* Grid::getNode(int y, int x){
	return &field[y][x];
}

int Grid::getN(){
	return this->n;
}

//get coordinates of the node on the grid based on the node ID
int Grid::getXbyID(int id){
	//std::cout << "id: " << id <<" get x by id: " << id % n << " in int: " << (int) id % n<<std::endl;
	return id % n;
} 
int Grid::getYbyID(int id){
	//std::cout << "id: " << id <<" get y by id: " << id / n << " in int: " << (int) id / n<<std::endl;
	return id / n;
}

//get id of node from coords
int Grid::getIDbyCoords(int y, int x){
	return y*n+x;
}


//get the ID of the tracked node
int Grid::getTracked(){
	int v = n/2;
	v=v+1;
	return ((v) * n) - v ; //povleku bolj gor
}


}

