/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef GRID_SN_H
#define GRID_SN_H

#include <vector>
#include "ns3/wirednode.h"
#include "wirednodegrid.h"

typedef std::vector<ns3::WiredNode> Array ;
typedef std::vector<Array> GridNetwork;


/*
*
* Class that manages the grid of sensor nodes
* each node a cell of a 2D array
*
*/


namespace ns3 {

/* ... */

	class Grid : public Object{

	public:


		static TypeId GetTypeId (void);

		Grid ();
  		virtual ~Grid();

  		void initialize(int n);
  		void initializeGrid(int n);

		void addNode(int y, int x, Ptr<Node> node);
		WiredNode* getNode(int y, int x);

		int getXbyID(int id);
		int getYbyID(int id);
		int getIDbyCoords(int y , int x);
		int getN();
		int getTracked();
		bool isGrid(void); //return if is grid -> true , false if diagonal

		GridNetwork field;

		int n;
		bool is_grid = false;


	};

}

#endif /* GRID_SN_H */

