/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */

#include "wirednode.h"

namespace ns3 {



WiredNode::WiredNode() {

	for (int i = 0; i < 3; ++i)
	{
		devices.push_back(Row());
		netDevs.push_back(Nic());
		
	}
	for (int i = 0; i < 3; ++i)
	{
		for (int j = 0; j < 3; ++j)
		{
			devices[j].push_back(0);
			netDevs[j].push_back(ns3::NetDeviceContainer());
		}
		
	}
}

WiredNode::~WiredNode() {}

void WiredNode::insertNode(Ptr<Node> n,int y, int x) {
	this->theNode = n;
	this->y = y;
	this->x = x;
}

Ptr<Node> WiredNode::getNode() {
	return theNode;
}


void WiredNode::setDevice(int y, int x, int addr) {
	devices[y][x]=addr;
}

void WiredNode::setNetDevice(int y, int x, NetDeviceContainer nc) {
	netDevs[y][x]=nc;
}


int WiredNode::getDevice(int y, int x){
	return devices.at(y).at(x);
}

NetDeviceContainer WiredNode::getNetDevice(int y, int x){
	return netDevs.at(y).at(x);
}

// void WiredNode::setInterface(Ipv4InterfaceContainer c) {
// 	this->theInterface.Add(c);
// }

void WiredNode::setCoords(int y, int x){
	this->y = y;
	this->x = x;
}

int WiredNode::getX(){
	return this->x;
}

int WiredNode::getY(){
	return this->y;
}



void WiredNode::addDevice(int addr, WiredNode* n2, NetDeviceContainer nc){

	int cX = n2->getX() - this->x +1;
	int cY = n2->getY() - this->y +1;
	//std::cout << "X" << cX << " cY" << cY<<  std::endl;
	//you don't need to checkkk
	this->setDevice(cY,cX,addr);
	this->setNetDevice(cY,cX,nc);

}



//get address where to send the data 
int WiredNode::getAddress(WiredNode* n2){
	int xx = n2->getX() - this->x;
	int yy = n2->getY() - this->y;
	
	//std::cout << " y: "<<yy<< " x: "<< xx <<std::endl;

	if(yy<0 && xx==0){
		return n2->getDevice(2,1);
	}
	if(yy<0 && xx<0){
		return n2->getDevice(2,2);
	}
	if(yy==0 && xx<0){
		return n2->getDevice(1,2);
	}
	if(yy>0 && xx<0){
		return n2->getDevice(0,2);
	}
	if(yy>0 && xx==0){
		return n2->getDevice(0,1);
	}
	if(yy>0 && xx>0){
		return n2->getDevice(0,0);
	}
	if(yy==0 && xx>0){
		return n2->getDevice(1,0);
	}
	if(yy<0 && xx>0){
		return n2->getDevice(2,0);
	}
	return 0;

}


//get address where to send the data 
NetDeviceContainer WiredNode::getNetDevByNode(WiredNode* n2){
	int xx = n2->getX() - this->x;
	int yy = n2->getY() - this->y;
	
	//std::cout << " y: "<<yy<< " x: "<< xx <<std::endl;

	if(yy<0 && xx==0){
		return n2->getNetDevice(2,1);
	}
	if(yy<0 && xx<0){
		return n2->getNetDevice(2,2);
	}
	if(yy==0 && xx<0){
		return n2->getNetDevice(1,2);
	}
	if(yy>0 && xx<0){
		return n2->getNetDevice(0,2);
	}
	if(yy>0 && xx==0){
		return n2->getNetDevice(0,1);
	}
	if(yy>0 && xx>0){
		return n2->getNetDevice(0,0);
	}
	if(yy==0 && xx>0){
		return n2->getNetDevice(1,0);
	}
	if(yy<0 && xx>0){
		return n2->getNetDevice(2,0);
	}
	return NetDeviceContainer();
}

void WiredNode::printDevices(){

	std::string str = "";
	int c = 0;

	for (int i = 0; i < 3; ++i)
	{
		for (int j = 0; j < 3; ++j)
		{
			str = str +", "+ std::to_string(c) +"-"+std::to_string(devices[i][j]);
			c++;
		}
		
	}

	std::cout << str <<std::endl;

}



}

