/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef WIREDNODE_H
#define WIREDNODE_H

#include <vector>
#include "ns3/core-module.h"
#include "ns3/point-to-point-module.h"
#include "ns3/network-module.h"
#include "ns3/ipv4-address-helper.h"
#include "ns3/ipv4-interface-container.h"
#include "ns3/ipv4-list-routing-helper.h"
#include "ns3/ipv4-static-routing-helper.h"
#include "ns3/log.h"
#include "ns3/log-macros-disabled.h"
#include "ns3/net-device-container.h"
#include "ns3/node-container.h"
#include <string>



typedef std::vector<int> Row ;
typedef std::vector<Row> DevicesMy;

typedef std::vector<ns3::NetDeviceContainer> Nic ;
typedef std::vector<Nic> NetDevices;


/*
*
* Class that manages information of sensor nodes
* containging details about addresses of neighbours
*
*/


namespace ns3 {

/* ... */

	class WiredNode{

  	public:
		WiredNode ();
  		virtual ~WiredNode();

  		void insertNode(Ptr<Node> n,int y, int x);
  		Ptr<Node> getNode();
  		void setDevice(int y, int x, int addr);
  		void setNetDevice(int y, int x, NetDeviceContainer nc);
  		//void setInterface(Ipv4InterfaceContainer c);

  		void setCoords(int y, int x);
  		int getX();
  		int getY();

  		//get address of the device at n2
  		int getAddress(WiredNode* n2);
  		NetDeviceContainer getNetDevByNode(WiredNode* n2);

  		void addDevice(int addr, WiredNode* n2,NetDeviceContainer nc);
  		int getDevice(int y, int x);
  		NetDeviceContainer getNetDevice(int y, int x);
  		void printDevices(void);

  		Ptr<Node>	theNode;
		Ipv4InterfaceContainer 			theInterface;

		DevicesMy 						devices;

		NetDevices 						netDevs;

		//coordinates on the SN
		int x;
		int y;

	};

}

#endif /* WIREDNODE_H */

