/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef WSENSOR_NODE_H
#define WSENSOR_NODE_H


#include <fstream>
#include <iostream>
#include <string>

#include <vector>

#include "ns3/application.h"
#include "ns3/wsimulationmanager.h"
#include "ns3/internet-module.h"
#include "ns3/core-module.h"
#include "ns3/network-module.h"
#include "ns3/internet-module.h"
#include "ns3/point-to-point-module.h"
#include "ns3/address.h"
#include "ns3/applications-module.h"
#include "ns3/event-id.h"
#include "ns3/grid-sn.h"
#include "ns3/wirednode.h"
#include "ns3/timepacket.pb.h"
#include "ns3/gridHeader.h"
//#include "ns3/protocolTrailer.h"
#include "ns3/wirednodegrid.h"
#include "ns3/mac48-address.h"
#include <string>
#include <algorithm>
//#include <random>


namespace ns3 {


class Wsensor_node : public Application
{
public:
  static TypeId GetTypeId (void);
  Wsensor_node ();
  virtual ~Wsensor_node();

  //sending & receiving
  void Send (int destination, WiredNode* a);
  void HandleRead (Ptr<Socket> socket);
  void SendPackets (void);

  //basic things to configure
  void Configure (void);

  //helper function
  int indexFromId(int id);
  void check(void);
  void silentCheck(void);
  void resetCheck(void);
  std::string getLogiCoordsById(int id);//get logical coordinates by id of sensor node in respect to the kernel



protected:
  uint16_t                  m_port; //port of the application
  Ptr<WsimulationManager>    m_sim_manager;
  Ptr<Grid>                 m_grid;
  Ipv4Address               m_address; //address of the node on which is running this application
  Ptr<Socket>               m_socket;
  InetSocketAddress         local;
  EventId                 m_sendEvent;
  Ipv4Address               dest_address;

  int trackId; //id of the node to be tracked
  int m_x;//grid coordinates of the node
  int m_y;
  int m_id; //node id
  WiredNodeGrid*    m_node;  //the actual node 
  WiredNode*        base_node;
  int seq = 0;
  uint16_t m_k; //kernel size
  uint16_t packNum; //number of packet sent

  uint16_t packetSize; //packet size in bytes
  double dataRate; //link datarate in Mbps

  Ptr<UniformRandomVariable> rnd = CreateObject<UniformRandomVariable> ();

  std::vector<int> recvList; //list of ip
  std::vector<int> sndList; //list of id
  std::vector<int> checkRecv;

  int pSent = 0;



private:
  virtual void StartApplication (void);
  virtual void StopApplication (void);




};
}

#endif /* WSENSOR_NODE_H */
