/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */

#include "wsimulationmanager.h"



namespace ns3 {


//Zagotovi, da se registrira TypeId
NS_OBJECT_ENSURE_REGISTERED (WsimulationManager);

NS_LOG_COMPONENT_DEFINE("WsimulationManager");



TypeId
WsimulationManager::GetTypeId (void)
{
	static TypeId tid = TypeId ("ns3::WsimulationManager")
	                    .SetParent<Object> ()
	                    .AddConstructor<WsimulationManager> ();
	return tid;
}

WsimulationManager::WsimulationManager() {}


WsimulationManager::WsimulationManager(std::string name) {


	//if filename exists -> remove
	std::remove(std::string("./grid_results/" + name + ".txt").c_str());

	Ptr<OutputStreamWrapper> StreamWrapper = Create<OutputStreamWrapper> ("./grid_results/" + name + ".txt", std::ios::app);
	sim_streamWrapper = StreamWrapper;
	sim_name = name;


}


WsimulationManager::~WsimulationManager() {

}


void WsimulationManager::printTest() {

	NS_LOG_INFO ("OUTPUT MANAGER READY");


}

void WsimulationManager::printIntro(std::string intro)
{
	intro = intro + "\n------------------------------------------------------------------------------------------\n";
	//intro = intro + "Simulation name: "+sim_name+"\n";
	std::string data = intro + ttp_header + "\n" + lost_header+ "\n" + all_lost_header;

	printLine(data);
}




void WsimulationManager::printLine(std::string line)
{
	std::ostream *stream = sim_streamWrapper->GetStream ();
	*stream << line << std::endl;
}


std::string WsimulationManager::ipv4ToString(Ipv4Address ip)
{
	std::stringstream ss;
	ip.Print (ss);
	return ss.str();
}


std::string WsimulationManager::currentTime()
{
	time_t givemetime = time(NULL);
	std::string timme = std::string( ctime(&givemetime));
	return timme.substr(0, timme.length() - 5);
}

void WsimulationManager::setTopology(std::string to){
	this->topo = to;
}



void WsimulationManager::ttp(int node_id,int k, double dr, int seq_num, int from_id , std::string str,Time tt){
	printLine("ttp,"+sim_name +","+topo+","+ std::to_string(node_id)+","+ std::to_string(k)+","+ std::to_string(dr)+","+ std::to_string(seq_num)+","+ std::to_string(from_id)+","+str+","+std::to_string(tt.GetSeconds()) );
}



void WsimulationManager::lost(int node_id, int k,double dr, int seq_num, int from_id,std::string str){
	printLine("lost,"+sim_name +","+topo+","+ std::to_string(node_id)+","+ std::to_string(k)+","+ std::to_string(dr)+","+ std::to_string(seq_num)+","+ std::to_string(from_id)+","+str);
}


void WsimulationManager::all_lost(int node_id, int k,double dr, int seq_num, int from_id,std::string str){
	printLine("all_lost,"+sim_name +","+topo+","+ std::to_string(node_id)+","+ std::to_string(k)+","+ std::to_string(dr)+","+ std::to_string(seq_num)+","+ std::to_string(from_id)+","+str);
}



void WsimulationManager::packetsSent(uint32_t pSent){
	this->totSentPackets += pSent;
}


uint64_t WsimulationManager::getTotPacketsSent(){
	return totSentPackets;
}


}