/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef WSIMULATIONMANAGER_H
#define WSIMULATIONMANAGER_H


#include <iostream>
#include <fstream>
#include <string>
#include <fstream>
#include "ns3/core-module.h"
#include <vector>
#include "ns3/output-stream-wrapper.h"
#include "ns3/internet-module.h"
#include <time.h>

//MANAGES THE OUTPUT OF THE SIMULATION

namespace ns3 {


class WsimulationManager : public Object {


public:



	WsimulationManager();
	WsimulationManager(std::string name);
	~WsimulationManager();

	static TypeId GetTypeId (void);

	void printTest();

	//Print simulation details on each file
	void printIntro(std::string intro);



	//print a line on file
	void printLine(std::string line);

	//other
	std::string ipv4ToString(Ipv4Address ip);
	std::string currentTime(void);
	void setTopology(std::string to);

	//print data of nodes
	void ttp(int node_id,int k, double dr, int seq_num, int from_id ,std::string str, Time tt);
	void lost(int node_id, int k, double dr, int seq_num, int from_id,std::string str);
	void all_lost(int node_id, int k, double dr, int seq_num, int from_id,std::string str); //packet lost across all the network


	Ptr<OutputStreamWrapper> 	sim_streamWrapper;


	//simulation name
	std::string 				sim_name;
	//topology
	std::string 				topo;

	uint64_t					totSentPackets = 0;

	//HEADERS
	std::string 				ttp_header = "TRAVELING_TIME_PACKET:sim_name,topology,node_id,k,dr,seq_num,from_id,logi_y,logi_x,tt";
	std::string 				lost_header = "PACKET_LOST:sim_name,topology,node_id,k,dr,seq_num,from_id,logi_y,logi_x";
	std::string 				all_lost_header = "ALL_LOST:sim_name,topology,node_id,k,dr,seq_num,from_id,y,x";

	void packetsSent(uint32_t pSent);
	uint64_t getTotPacketsSent();


};

}



#endif /* WSIMULATIONMANAGER_H */