#include "gridHeader.h"
#include "ns3/header.h"
#include "ns3/network-module.h"
#include "ns3/keyHandler.h"

namespace ns3 {

//Zagotovi, da se registrira TypeId
NS_OBJECT_ENSURE_REGISTERED (GridHeader);


	TypeId
	GridHeader::GetTypeId (void)
	{
		static TypeId tid = TypeId ("ns3::GridHeader")
     .SetParent<Header> ()
     .AddConstructor<GridHeader> ()
     .SetGroupName("Network");
   return tid;

	}

	//nic vaznega neznam kaj rabi - obvezno, ker je bilo virtual
	TypeId GridHeader::GetInstanceTypeId (void) const{
		return GetTypeId ();
	}

	GridHeader::GridHeader(){}

	GridHeader::~GridHeader(){}

	//nastavi protobuf object
	void 
	GridHeader::SetData (timepacket::pHeader packetT)
	{
	  pTime = packetT;
	}
	
	//vrne protobuf object
	timepacket::pHeader  GridHeader::GetData (void)
	{
	  return pTime;
	}

	//Kontruktor, ki sprejme protobuf object
	GridHeader::GridHeader(timepacket::pHeader packetT):pTime(packetT){
		pTime = packetT;
		//std::cout << "In protocol header " << onion_message.ByteSizeLong() << std::endl;
	}


	

	uint32_t GridHeader::GetSerializedSize (void) const{

		int size = pTime.ByteSizeLong();
	
		if(size == 0 || size == -1){
			std::cout << "message not set " << std::endl;
		}
		//4B where the size of the serialization is stored
		return  size + 4; 
	}
	
   	void GridHeader::Serialize (Buffer::Iterator start) const{
   		uint32_t size = pTime.ByteSizeLong(); 
   		uint8_t* array = new uint8_t[size+4];
   		//std::cout << size << std::endl;
   		array[0] = size;
    	array[1] = size >> 8;
    	array[2] = size >> 16;
    	array[3] = size >> 24;
   		//std::cout <<(int)array[0]<<" "<<(int)array[1]<<" "<<(int)array[2]<<" " <<(int)array[3] << std::endl;
  		pTime.SerializeToArray(&array[4],size);
  		//std::cout <<(int)array[0]<<" "<<(int)array[1]<<" "<<(int)array[2]<<" " <<(int)array[3] << std::endl;
  		Buffer::Iterator i = start;
  		i.Write(array,size+4);
  		//std::cout << "seri " << std::endl;
   	}
   	uint32_t GridHeader::Deserialize (Buffer::Iterator start){

   		
   		Buffer::Iterator i = start;
   		uint8_t* size_arr = new uint8_t[4];
   		int size = 0;
   		i.Read(size_arr,4);
   		//std::cout <<(int)size_arr[0]<<" "<<(int)size_arr[1]<<" "<<(int)size_arr[2]<<" " <<(int)size_arr[3] << std::endl;
   		memcpy(&size,&size_arr[0],4);
   		//std::cout << size << std::endl;
   		uint8_t* array = new uint8_t[size];
   		i.Read(array,size);
   		pTime.ParseFromArray(array,size);
   		//std::cout << "deseri " << std::endl;
   		return size + 4;
   	}

   	//Ne implementirano
   	void GridHeader::Print (std::ostream &os) const{
   		//std::cout << "Print not implemented" << std::endl;
   		
   		os << "HEADEEEERRR";
   	}
	

}